package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Signature;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.Hex2DDeserializer;
import io.accumulatenetwork.sdk.support.serializers.Hex2DSerializer;
// UnionType: SignatureType
// UnionValue: Remote

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("RemoteSignature")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class RemoteSignature implements Signature {
	public final SignatureType type = SignatureType.REMOTE;
	private Url destination;
	private Signature signature;
	private byte[][] cause;

    //
	public Url getDestination() {
	    return destination;
	}
	public void setDestination(final Url value) {
	    this.destination = value;
	}

	public RemoteSignature destination(final Url value) {
	    setDestination(value);
	    return this;
	}
	public RemoteSignature destination(final String value) {
	    setDestination(Url.toAccURL(value));
	    return this;
	}
	public Signature getSignature() {
	    return signature;
	}
	public void setSignature(final Signature value) {
	    this.signature = value;
	}

	public RemoteSignature signature(final Signature value) {
	    setSignature(value);
	    return this;
	}
	@JsonDeserialize(using = Hex2DDeserializer.class)
	public byte[][] getCause() {
	    return cause;
	}
	@JsonSerialize(using = Hex2DSerializer.class)
	public void setCause(final byte[][] value) {
	    this.cause = value;
	}

	public RemoteSignature cause(final byte[][] value) {
	    setCause(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.destination == null)) {
            marshaller.writeUrl(2, this.destination);
        }
        if (!(this.signature == null)) {
            marshaller.writeValue(3, signature);
        }
        if (!(this.cause == null || this.cause.length == 0)) {
            marshaller.writeHash(4, this.cause);
        }
        return marshaller.array();
    }
}
